
   '***********************************************************************************************************************
   'Software Fernsteuerung DTMF -- Copyright IW3AMQ
   '***********************************************************************************************************************
   'DTMF Fernsteuerung mit 8 + 8 + 4 Ausgngen zum Anschluss an ein Funkgert; mit Kontrolle, ob RTX ein

   'Kurzbeschreibung: Password (siehe unter "Anfangssettierung des Passwortes" = 031262*1 , wobei fr *1 die Fernsteuerung
   'auf dem Gantkofel, fr *2 fr Plose, *3 fr Bondone gedacht ist.

   'Nach Besttigung der korrekten Passworteingabe (Doppelton
   'tief dann hoch, kann der status abgefragt oder gendert werden.

   'Abfrage: Pinnummer + Abfragesymbol (*) => A1* fr Pin A1, A2* fr Pin A2 bis A8*, von B1* bis B8*, von C1* bis C4*
   'ndern: Pinnummer + nderungssymbol (#) => A1# fr Pin A1, usw. wie oben

   'bei jeder Abfrage oder nderung wird der effektive Status sofort zurckgesendet:
   'Ton hoch, Ton tief => Status low (0)
   'Ton tief, ton hoch => status high (1),

   'mit 000 werden alle Ausgnge auf low geschalten,
   'mit 111 werden alle Ausgnge auf high geschalten,

   'mit *** wird die Fernsteuerung abgeschlossen.

   'Die Fernsteuerung hat auch ein Timeout von ca. 60 sekunden (einstellbar unter "Definition der Konstanten", nach denen sie
   'selbst abschliet

   'ZUSAMMENFASSUNG:

   'Password: xxxxxxxx (8 Zeichen, wobei x = 0 bis 9, *, #, A bis D)   BEI NEUINSTALLATION IST DAS PASSWORD: 12345678 und alle
   'Ausgnge auf low!

   'Abfrage Status: A1* ... A8*; NICHT VERFGBAR (wenn gebraucht wird, dann Zeilen am Ende des prg verschieben!) => B1* ... B8*; C1* ... C4*
   'ndere Status:  A1# ... A8#; NICHT VERFGBAR (wenn gebraucht wird, dann Zeilen am Ende des prg verschieben!) => B1# ... B8#; C1# ... C4#
   'Alle Ausgnge auf high: 111
   'Alle Ausgnge auf low: 000
   'Password ndern: DD#
   'Verlassen: ***

   '''=noch nicht programmiert

   '''Alle Ausgnge Port A (8 Pins) auf high: AA1
   '''Alle Ausgnge Port A (8 Pins) auf low: AA0
   '''Alle Ausgnge Port B (8 Pins) auf high: BB1
   '''Alle Ausgnge Port B (8 Pins) auf low: BB0
   '''Alle Ausgnge Port C (4 Pins) auf high: CC1
   '''Alle Ausgnge Port C (4 Pins) auf low: CC0

   '***********************************************************************************************************************

   'Systemeinstellungen
   '***********************************************************************************************************************

   $regfile = "m8535.dat"
   $crystal = 4000000                                       'oder 3596000, wenn mit DTMF Quarz verbunden!
   Config Watchdog = 2048                                   'watchdog zeit in ms
   Dim Kontrolle_rtx As Bit


   'Definition der Konstanten
   '***********************************************************************************************************************

   Const Timeout1 = 2000                                    'timeout fr passwordeingabe in ms, falls erste zahlen richtig, zaehler0 auf 1
   Const Timeout2 = 30000                                   'timeout fr eingabe fernsteuerung in ms, danach erneute passworteingabe
   Const Tx_delay = 1000                                    'zeitverzgerung in ms vom ptt (max. 2048 wenn watchdog aktiv!)
   Const Nf_delay = 500                                     'zeitverzgerung in ms zwischen ptt und nf-aussendung (max. 2048 wenn watchdog aktiv!)
   Const Ton_hoch = 400                                     'anzahl impulse fr hohen ton
   Const Ton_tief = 800                                     'anzahl impulse fr tiefen Ton
   Const Dauer_tonhoch = 100                                'dauer der impulse
   Const Dauer_tontief = 80                                 'dauer der impulse
'   Kontrolle_rtx = 0                                        'wenn 1 = aktiv => kontrolliere, ob rtx eingeschalten ist, falls ausgeschalten, einschalten

   Const Led_time = 24000                                   'led wird alle led_time zeit aktiviert, um aktivitt uP zu kontrollieren
   Const Kennungtx = 500                                    'Wiederholung der kennung in sekunden ca.!!    10 minuten = wert auf 500)
   Const Timeouttx = 4                                      'in minuten - timeout bei dauer TX
   Const Timeoutrx = 3                                      'in sekunden - timeouttimer fr RX nach einem TX timeout, d.h. es muss fr min. die zeit timeoutrx nicht auf TX gegangen werden, damit TX timeout resettiert wird (gegen ciak, ciak effekt!)

   'Definition der Variablen
   '***********************************************************************************************************************

   Dim Merker As Word
   Dim Merker2 As Bit
   Dim Dauer As Word
   Dim Zaehler_tx As Long                                   'zhler fr tx timeout
   Dim Timeout_tx As Long                                   'variable fr erreichte zeit fr timeout
   Dim Timeout_tx1 As Long                                  'variable fr erreichte zeit fr timeout, aber 1 minute frher (nur warnung!)
   Dim Zaehler_rx As Long                                   'zhler fr rx timeout - d.h. nach einem TX timeout muss fr mindestens x sekunden der RX nichts empfangen, bevor txtimeout resettiert wird (um ciak, ciak, ciak phnomen zu vermeiden!)
   Dim Timeout_rx As Long                                   'variable fr erreichte zeit fr timeout
   Dim Merke_timeout As Bit                                 'merker fr tx timeout

   Dim Decode_ok As Bit                                     'merker fr dtmf dekodiert
   Dim Pw_ok As Bit                                         'merker fr password erkannt
   Dim Zaehler0 As Byte                                     'zhler fr anzahl nummern password zugang
   Dim Zaehler1 As Long                                     'timeout zhler
   Dim Zaehler2 As Long                                     'zhler fr anzahl nummern password ausgnge
   Dim Zaehler3 As Long                                     'zhler fr timout, wenn keine eingabe mehr erfolgt
   Dim Zaehler4 As Long                                     'zhler fr anzahl nummern password ndern
   Dim Zaehler5 As Byte                                     '
   Dim Zaehler6 As Long                                     'zhler fr ansage ir3brc
   Dim Pos As Byte                                          'zaehler fr position eeprom
   Dim Nummer As Byte                                       'ermittelte nummer dtmf
   Dim Wert0 As Byte
   Dim Wert1 As Byte
   Dim Num(3) As Byte

   Dim Pw(8) As Byte                                        'password fr Zugang
   Dim Pw_a1(3) As Byte                                     'password fr Ausgang
   Dim Pw_a2(3) As Byte                                     'password fr Ausgang
   Dim Pw_a3(3) As Byte                                     'password fr Ausgang
   Dim Pw_a4(3) As Byte                                     'password fr Ausgang
   Dim Pw_a5(3) As Byte                                     'password fr Ausgang
   Dim Pw_a6(3) As Byte                                     'password fr Ausgang
   Dim Pw_a7(3) As Byte                                     'password fr Ausgang
   Dim Pw_a8(3) As Byte                                     'password fr Ausgang
   Dim Pw_b1(3) As Byte                                     'password fr Ausgang
   Dim Pw_b2(3) As Byte                                     'password fr Ausgang
   Dim Pw_b3(3) As Byte                                     'password fr Ausgang
   Dim Pw_b4(3) As Byte                                     'password fr Ausgang
   Dim Pw_b5(3) As Byte                                     'password fr Ausgang
   Dim Pw_b6(3) As Byte                                     'password fr Ausgang
   Dim Pw_b7(3) As Byte                                     'password fr Ausgang
   Dim Pw_b8(3) As Byte                                     'password fr Ausgang
   Dim Pw_c1(3) As Byte                                     'password fr Ausgang
   Dim Pw_c2(3) As Byte                                     'password fr Ausgang
   Dim Pw_c3(3) As Byte                                     'password fr Ausgang
   Dim Pw_c4(3) As Byte                                     'password fr Ausgang
   Dim Pw_end(3) As Byte                                    'password fr ende
   Dim Pw_set(3) As Byte                                    'passwort setzt alle Ausgnge auf high
   Dim Pw_res(3) As Byte                                    'passwort setzt alle Ausgnge auf low
   Dim Pw_var As Bit                                        'setzen des bits, wenn passwort fr passwortnderung erkannt
   Dim Pw_aendere(3) As Byte                                'passwort fr passwortnderung

   Dim Pin As Integer                                       'wert der den ausgangspin zjm passwort kombiniert
   Dim Nr_eeprom As Byte

   Dim Aa1 As Byte
   Dim Aa2 As Byte
   Dim Aa3 As Byte
   Dim Aa4 As Byte
   Dim Aa5 As Byte
   Dim Aa6 As Byte
   Dim Aa7 As Byte
   Dim Aa8 As Byte
   Dim Ab1 As Byte
   Dim Ab2 As Byte
   Dim Ab3 As Byte
   Dim Ab4 As Byte
   Dim Ab5 As Byte
   Dim Ab6 As Byte
   Dim Ab7 As Byte
   Dim Ab8 As Byte
   Dim Ac1 As Byte
   Dim Ac2 As Byte
   Dim Ac3 As Byte
   Dim Ac4 As Byte

   Dim Ausgang(20) As Byte

   'Definition Ports I/O
   '***********************************************************************************************************************

   'Definition der Eingnge
   '***********************************************************************************************************************

   Config Pind.7 = Input                                    'Eingang Q1 vom MT8870 DTMF IC
   Config Pind.6 = Input                                    'Eingang Q2 vom MT8870 DTMF IC
   Config Pind.5 = Input                                    'Eingang Q3 vom MT8870 DTMF IC
   Config Pind.4 = Input                                    'Eingang Q4 vom MT8870 DTMF IC
   Config Pind.3 = Input                                    'Eingang STD vom MT8870 DTMF IC
   Config Pinc.3 = Input                                    'Eingang Vin zur Kontrolle ob Funkgert eingeschalten ist bzw. TX Kriterium ein fr Timeout

   'Benennung dieser Eingnge
   Q1 Alias Pind.7                                          'Eingang Q1 vom MT8870 DTMF IC
   Q2 Alias Pind.6                                          'Eingang Q2 vom MT8870 DTMF IC
   Q3 Alias Pind.5                                          'Eingang Q3 vom MT8870 DTMF IC
   Q4 Alias Pind.4                                          'Eingang Q4 vom MT8870 DTMF IC
   Q5 Alias Pind.3                                          'Eingang STD vom MT8870 DTMF IC
   Vin Alias Pinc.3                                         'Eingang Vin zur Kontrolle ob Funkgert eingeschalten ist bzw. TX Kriterium ein fr Timeout

   'Setzen der Pullup / Pulldown Widerstnde dieser Eingnge
   Reset Portc.3                                            'pulldown auf Vin eingang
'   Set Portb.1


   'Definition der Ausgnge (4 Rele)
   '***********************************************************************************************************************

   Config Pinc.0 = Output                                   'RTX: NF Signalisierung out TX
   Config Pinc.1 = Output                                   'RTX: Ptt
   Config Pinc.2 = Output                                   'RTX: RTX wird eingeschalten, wenn Vin auf 0 (Transistor NPN drckt Taste on

   Config Pind.0 = Output                                   'Kontrollled fr Passwort DTMF ok

   Config Porta = Output                                    'SV2 Stecker - 8 Ausgnge ber 100 ohm Widerstnde (pin 2,4,8,10,12,14,16,18)

   Config Portb = Output                                    'SV1 Stecker - 8 Ausgnge ber 100 ohm Widerstnde (pin 1,3,5,7,9,11,13,15)

   Config Pinc.4 = Output                                   'SV1 Stecker - 4 Ausgnge ber 100 ohm Widerstnde (pin 18,20,19,17)
   Config Pinc.5 = Output
   Config Pinc.6 = Output
   Config Pinc.7 = Output


   'Benennung dieser Ausgnge
   Nfout Alias Portc.0                                      'Nf signalisierung TX
   Ptt Alias Portc.1                                        'PTT Rtx
   Rtx Alias Portc.2                                        'RTX einschalten

   Led Alias Portd.0                                        'led fr dtmf ok

   A1 Alias Portb.0                                         'SV2 Stecker - Ausgang A0 = pin 2 vom Stecker
   A2 Alias Portb.1                                         'SV2 Stecker - Ausgang A1 = pin 4 vom Stecker
   A3 Alias Portb.2                                         'SV2 Stecker - Ausgang A2 = pin 6 vom Stecker
   A4 Alias Portb.3                                         'SV2 Stecker - Ausgang A3 = pin 8 vom Stecker
   A5 Alias Portb.4                                         'SV2 Stecker - Ausgang A4 = pin 10 vom Stecker
   A6 Alias Portb.5                                         'SV2 Stecker - Ausgang A5 = pin 12 vom Stecker
   A7 Alias Portb.6                                         'SV2 Stecker - Ausgang A6 = pin 14 vom Stecker
   A8 Alias Portb.7                                         'SV2 Stecker - Ausgang A7 = pin 16 vom Stecker

   B1 Alias Porta.0                                         'SV1 Stecker - Ausgang B0 = pin 1 vom Stecker
   B2 Alias Porta.1                                         'SV1 Stecker - Ausgang B1 = pin 3 vom Stecker
   B3 Alias Porta.2                                         'SV1 Stecker - Ausgang B2 = pin 5 vom Stecker
   B4 Alias Porta.3                                         'SV1 Stecker - Ausgang B3 = pin 7 vom Stecker
   B5 Alias Porta.4                                         'SV1 Stecker - Ausgang B4 = pin 9 vom Stecker
   B6 Alias Porta.5                                         'SV1 Stecker - Ausgang B5 = pin 11 vom Stecker
   B7 Alias Porta.6                                         'SV1 Stecker - Ausgang B6 = pin 13 vom Stecker
   B8 Alias Porta.7                                         'SV1 Stecker - Ausgang B7 = pin 15 vom Stecker

   C1 Alias Portc.4                                         'SV1 Stecker - Ausgang B8 = pin 18 vom Stecker
   C2 Alias Portc.5                                         'SV1 Stecker - Ausgang B9 = pin 20 vom Stecker
   C3 Alias Portc.6                                         'SV1 Stecker - Ausgang B10 = pin 19 vom Stecker
   C4 Alias Portc.7                                         'SV1 Stecker - Ausgang B11 = pin 17 vom Stecker


   'Anfangssettierung der Ausgnge (con3 und con4) - Lesen der gesetzten Ausgnge im Eeprom
   '***********************************************************************************************************************

   Readeeprom Aa1 , 1
   Readeeprom Aa2 , 2
   Readeeprom Aa3 , 3
   Readeeprom Aa4 , 4
   Readeeprom Aa5 , 5
   Readeeprom Aa6 , 6
   Readeeprom Aa7 , 7
   Readeeprom Aa8 , 8
   Readeeprom Ab1 , 9
   Readeeprom Ab2 , 10
   Readeeprom Ab3 , 11
   Readeeprom Ab4 , 12
   Readeeprom Ab5 , 13
   Readeeprom Ab6 , 14
   Readeeprom Ab7 , 15
   Readeeprom Ab8 , 16
   Readeeprom Ac1 , 17
   Readeeprom Ac2 , 18
   Readeeprom Ac3 , 19
   Readeeprom Ac4 , 20

   A1 = Aa1 : A2 = Aa2 : A3 = Aa3 : A4 = Aa4 : A5 = Aa5 : A6 = Aa6 : A7 = Aa7 : A8 = Aa8       'sezte die Ausgnge auf den Werten des EEproms
   B1 = Ab1 : B2 = Ab2 : B3 = Ab3 : B4 = Ab4 : B5 = Ab5 : B6 = Ab6 : B7 = Ab7 : B8 = Ab8
   C1 = Ac1 : C2 = Ac2 : C3 = Ac3 : C4 = Ac4

   Rtx = 0

   Led = 0
   Decode_ok = 0
   Zaehler0 = 1                                             'zhler fr anzahl dtmf nummern eingabe
   Zaehler1 = 0                                             'zhler fr timeout
   Zaehler2 = 1                                             'zhler fr anzahl der dtmf nummern fr pinnderung / auslesung
   Zaehler3 = 0                                             'zaehler fr timeout, wenn keine eingabe mehr erfolgt
   Zaehler4 = 0
   Zaehler5 = 1
   Zaehler6 = 0
   Wert0 = 0
   Wert1 = 1
   Pw_var = 0
   Zaehler_tx = 0
   Zaehler_rx = 0

   'Lese passwort aus eeprom, wenn alle nummern 255, dann scheibe standardpasswort 12345678
   '***********************************************************************************************************************************************************

Lese_pw_eeprom:
   For Pos = 1 To 8                                         'lese gespeicherte passwrter im eeprom (position 21 bis 28)
      Nr_eeprom = Pos + 31
      Readeeprom Pw(pos) , Nr_eeprom
   Next

   'schreibe Anfangsstatus der pins (0) und password (12345678) ins eeprom (position 21 bis 28), wenn eeprom noch nicht programmiert (alle haben &HFF=255)

   If Pw(1) = 255 And Pw(2) = 255 And Pw(3) = 255 And Pw(4) = 255 And Pw(5) = 255 And Pw(6) = 255 And Pw(7) = 255 And Pw(8) = 255 Then
      Pw(1) = 1 : Pw(2) = 2 : Pw(3) = 3 : Pw(4) = 4 : Pw(5) = 5 : Pw(6) = 6 : Pw(7) = 7 : Pw(8) = 8

      For Pos = 1 To 8
         Nr_eeprom = Pos + 31
         Writeeeprom Pw(pos) , Nr_eeprom
      Next

      For Pos = 1 To 20
         Writeeeprom Wert0 , Pos
      Next

   End If

   'Anfangssettierung der Fernsteuerbefehle
   '***********************************************************************************************************************************************************
   '0=D; 10=0; 11=*; 12=#; 13=A; 14=B; 15=C

   Pw_a1(1) = 11 : Pw_a1(2) = 13 : Pw_a1(3) = 1
   Pw_a2(1) = 11 : Pw_a2(2) = 13 : Pw_a2(3) = 2
   Pw_a3(1) = 11 : Pw_a3(2) = 13 : Pw_a3(3) = 3
   Pw_a4(1) = 11 : Pw_a4(2) = 13 : Pw_a4(3) = 4
   Pw_a5(1) = 11 : Pw_a5(2) = 13 : Pw_a5(3) = 5
   Pw_a6(1) = 11 : Pw_a6(2) = 13 : Pw_a6(3) = 6
   Pw_a7(1) = 11 : Pw_a7(2) = 13 : Pw_a7(3) = 7
   Pw_a8(1) = 11 : Pw_a8(2) = 13 : Pw_a8(3) = 8
   Pw_b1(1) = 11 : Pw_b1(2) = 14 : Pw_b1(3) = 1
   Pw_b2(1) = 11 : Pw_b2(2) = 14 : Pw_b2(3) = 2
   Pw_b3(1) = 11 : Pw_b3(2) = 14 : Pw_b3(3) = 3
   Pw_b4(1) = 11 : Pw_b4(2) = 14 : Pw_b4(3) = 4
   Pw_b5(1) = 11 : Pw_b5(2) = 14 : Pw_b5(3) = 5
   Pw_b6(1) = 11 : Pw_b6(2) = 14 : Pw_b6(3) = 6
   Pw_b7(1) = 11 : Pw_b7(2) = 14 : Pw_b7(3) = 7
   Pw_b8(1) = 11 : Pw_b8(2) = 14 : Pw_b8(3) = 8
   Pw_c1(1) = 11 : Pw_c1(2) = 15 : Pw_c1(3) = 1
   Pw_c2(1) = 11 : Pw_c2(2) = 15 : Pw_c2(3) = 2
   Pw_c3(1) = 11 : Pw_c3(2) = 15 : Pw_c3(3) = 3
   Pw_c4(1) = 11 : Pw_c4(2) = 15 : Pw_c4(3) = 4

   Pw_end(1) = 11 : Pw_end(2) = 11 : Pw_end(3) = 11         'Befehl fr Ende Fernsteuerung
   Pw_set(1) = 1 : Pw_set(2) = 1 : Pw_set(3) = 1            'Befehl stellt alle Ausgnge auf high
   Pw_res(1) = 10 : Pw_res(2) = 10 : Pw_res(3) = 10         'Befehl stellt alle Ausgnge auf low
   Pw_aendere(1) = 0 : Pw_aendere(2) = 0 : Pw_aendere(3) = 12       'Befehl fr Passwortnderung

   Timeout_tx = Timeouttx * 650000                          'Wert zur korrigierung, damit wert "timeout = 1" fr 1 Minute steht
   Timeout_tx1 = Timeouttx * 600000
   Timeout_rx = Timeoutrx * 12000                           'Wert zur korrigierung, damit wert "timeout = 1" fr 1 sekunde steht

   'kontrolle, ob RTX eingeschalten ist
   '***********************************************************************************************************************************************************

'Kontrolle_vin:
'   If Kontrolle_rtx = 1 Then
'      If Vin = 0 Then
'         Pulseout Portc , 2 , 500000
'         Wait 3
'         If Vin = 0 Then
'            Goto Kontrolle_vin
'         End If
'      End If
'   End If

   '***********************************************************************************************************************************************************
   'Hauptschleife
   '***********************************************************************************************************************************************************
   '***********************************************************************************************************************************************************

   Waitms 100                                               'warte, bis spannungen des mt8870 sich stabilisiert haben!!! (sonst ist fr einen moment q5 auf high!)
   Start Watchdog


Abfrage:
   Reset Watchdog

   '***********************************************************************************************************************************************************
   'Timeout Timer + Rcksetzen nach x sekunden frei

   Readeeprom Aa5 , 5                                       'nur wenn link aktiviert ist, dann kontrolle durch timeout (timeout betrifft nur richtfunk TX!!!)

   If Aa5 = 1 Then
      If Vin = 1 Then
         Zaehler_rx = 0                                     'kontrolle, ob RTX auf Sendung ist, fr timeout TX
         If Zaehler_tx < Timeout_tx Then
            Incr Zaehler_tx
            End If
         If Zaehler_tx = Timeout_tx Then
            Incr Zaehler_tx
            Gosub Ende1                                     'gebe warnton aus, wenn timeout erreicht ist
            Portb.4 = 0                                     'port der link aktiviert
            Merke_timeout = 1
            End If
         If Zaehler_tx = Timeout_tx1 Then
            Gosub Ende                                      'gebe warnton aus, wenn 1 Minute vor timeout erreicht ist
            End If
      Else
         If Zaehler_tx > 0 Then
            If Zaehler_rx < Timeout_rx Then
               Incr Zaehler_rx
               End If
            If Zaehler_rx = Timeout_rx Then
               A8 = 0                                       'sezte ausgang a8 auf 0, damit besttigungpieps nicht auf link gesendet wird
               If Merke_timeout = 1 Then
                  Gosub Best_hoch2
               Else
                  Gosub Best_biep
                  End If
               Zaehler_rx = 0
               Zaehler_tx = 0
               Merke_timeout = 0
               Portb.4 = 1
               Readeeprom Aa8 , 8                           'lese Status Ausgang A8 und stelle ihn wieder her
               A8 = Aa8
               End If
            End If
         End If
      End If


   '***********************************************************************************************************************************************************
   'steuere kontrollled an

   Incr Zaehler4

   If Zaehler4 = Led_time Then                              'lasse gelbe Led blinken, um Aktivitt des uP anzuzeigen
      Pulseout Portd , 0 , 3000
      Zaehler4 = 0
      Incr Zaehler6


   '***********************************************************************************************************************************************************
   'timer fr CW kennung

      If Zaehler6 = Kennungtx Then                          'ermittle timer fr CW kennung
         Zaehler6 = 0
         Gosub Ir3ubc
         End If
      End If


   If Q5 = 1 Then                                           'wenn standby dtmf=1 dann lese und summiere die anliegende zahl
      Nummer = Q4
      Shift Nummer , Left
      Nummer = Nummer + Q3
      Shift Nummer , Left
      Nummer = Nummer + Q2
      Shift Nummer , Left
      Nummer = Nummer + Q1
      Led = 1
      Decode_ok = 1
      Zaehler1 = 0
      Zaehler3 = 0
   Else
      Led = 0
      If Decode_ok = 1 Then
         Decode_ok = 0
         Goto Kontrolle
      End If

      If Zaehler0 > 1 Or Zaehler2 > 1 Or Zaehler5 > 1 Then
         Incr Zaehler1
         Waitms 1
         If Zaehler1 = Timeout1 Then                        'Timeout in ca. 5 sekunden, setze Zahlsequenzzaehler fr Password, pins und passwortnderung dann auf 0
            If Zaehler2 > 1 Or Zaehler5 > 1 Then
               Gosub Reset_zaehler
            End If
            Zaehler0 = 1
            Zaehler2 = 1
            Zaehler1 = 0
            Zaehler5 = 1
            Gosub Blink6                                    '6 Blinkimpulse am Led fr RESET
         End If
      End If

      If Pw_ok = 1 Then                                     'timeout, wenn keine eingabe nach erkennung password
         Incr Zaehler3
         Waitms 1
         If Zaehler3 = Timeout2 Then
            Pw_ok = 0
            Decode_ok = 0
            Zaehler0 = 1
            Zaehler1 = 0
            Zaehler2 = 1
            Zaehler3 = 0
            Zaehler5 = 1
            Gosub Ende
         End If
      End If
   End If
Goto Abfrage


Kontrolle:
   If Pw_var = 1 Then                                       'lese dtmf und speichere neues password in eeprom
      Pw(zaehler5) = Nummer
      Incr Zaehler5
         If Zaehler5 = 9 Then
            Zaehler5 = 1
            Pw_var = 0
            For Pos = 1 To 8
               Nr_eeprom = Pos + 31
               Writeeeprom Pw(pos) , Nr_eeprom
               Reset Watchdog
            Next
            Gosub Best_hoch2
         End If
      Goto Abfrage
   End If

   If Pw_ok = 0 Then                                        'lese dtmf und vergleiche password, falls noch nicht ok
      If Nummer = Pw(zaehler0) Then
'         Waitms 25
'         Pulseout Portd , 0 , 25000                         '1 Blinkimpuls am Led fr einzelne Nummer des Passwortes erkannt
         Incr Zaehler0
            If Zaehler0 = 9 Then
               Zaehler0 = 1
               Pw_ok = 1
               Gosub Best_hoch
               Gosub Blink2                                 '2 Blinkimpulse am Led fr Password erkannt
               Goto Abfrage
            End If
         Goto Abfrage
      Else
         Gosub Blink4                                       '4 Blinkimpulse am Led fr falsche Einzel Nummerneingabe
         Zaehler0 = 1
         Goto Abfrage
      End If
   Else
      Num(zaehler2) = Nummer
      Incr Zaehler2
      If Zaehler2 = 4 Then
         Zaehler2 = 1
         Goto Kontrolle_pin
      End If
      Goto Abfrage
   End If


Kontrolle_pin:
   If Num(1) = Pw_a1(2) And Num(2) = Pw_a1(3) Then
      If Num(3) = 12 Then
         Toggle A1
         Aa1 = A1
         Writeeeprom Aa1 , 1
      End If

      If Num(3) = 11 Or Num(3) = 12 Then
            If A1 = 1 Then
               Gosub Best_hoch
            Else
               Gosub Best_tief
            End If
         Goto Abfrage
      End If
   End If

   If Num(1) = Pw_a2(2) And Num(2) = Pw_a2(3) Then
      If Num(3) = 12 Then
         Toggle A2
         Aa2 = A2
         Writeeeprom Aa2 , 2
      End If

      If Num(3) = 11 Or Num(3) = 12 Then
            If A2 = 1 Then
               Gosub Best_hoch
            Else
               Gosub Best_tief
            End If
         Goto Abfrage
      End If
   End If

   If Num(1) = Pw_a3(2) And Num(2) = Pw_a3(3) Then
      If Num(3) = 12 Then
         Toggle A3
         Aa3 = A3
         Writeeeprom Aa3 , 3
      End If

      If Num(3) = 11 Or Num(3) = 12 Then
            If A3 = 1 Then
               Gosub Best_hoch
            Else
               Gosub Best_tief
            End If
         Goto Abfrage
      End If
   End If

   If Num(1) = Pw_a4(2) And Num(2) = Pw_a4(3) Then
      If Num(3) = 12 Then
         Toggle A4
         Aa4 = A4
         Writeeeprom Aa4 , 4
      End If

      If Num(3) = 11 Or Num(3) = 12 Then
            If A4 = 1 Then
               Gosub Best_hoch
            Else
               Gosub Best_tief
            End If
         Goto Abfrage
      End If
   End If

   If Num(1) = Pw_a5(2) And Num(2) = Pw_a5(3) Then
      If Num(3) = 12 Then
         Toggle A5
         Aa5 = A5
         Writeeeprom Aa5 , 5
      End If

      If Num(3) = 11 Or Num(3) = 12 Then
            If A5 = 1 Then
               Gosub Best_hoch
            Else
               Gosub Best_tief
            End If
         Goto Abfrage
      End If
   End If

   If Num(1) = Pw_a6(2) And Num(2) = Pw_a6(3) Then
      If Num(3) = 12 Then
         Toggle A6
         Aa6 = A6
         Writeeeprom Aa6 , 6
      End If

      If Num(3) = 11 Or Num(3) = 12 Then
            If A6 = 1 Then
               Gosub Best_hoch
            Else
               Gosub Best_tief
            End If
         Goto Abfrage
      End If
   End If

   If Num(1) = Pw_a7(2) And Num(2) = Pw_a7(3) Then
      If Num(3) = 12 Then
         Toggle A7
         Aa7 = A7
         Writeeeprom Aa7 , 7
      End If

      If Num(3) = 11 Or Num(3) = 12 Then
            If A7 = 1 Then
               Gosub Best_hoch
            Else
               Gosub Best_tief
            End If
         Goto Abfrage
      End If
   End If

   If Num(1) = Pw_a8(2) And Num(2) = Pw_a8(3) Then
      If Num(3) = 12 Then
         Toggle A8
         Aa8 = A8
         Writeeeprom Aa8 , 8
      End If

      If Num(3) = 11 Or Num(3) = 12 Then
            If A8 = 1 Then
               Gosub Best_hoch
            Else
               Gosub Best_tief
            End If
         Ptt = 0
         Goto Abfrage
      End If
   End If


'*********************************************************************************************************************
'ACHTUNG: FALLS B1 BIS B8 UND C1 bis C4 GESCHALTEN WERDEN SOLL DANN ZEILEN AM ENDE DES PROGRAMMES HIER HINZUFGEN!!!!!!!!!!
'*********************************************************************************************************************


   If Num(1) = Pw_res(1) And Num(2) = Pw_res(2) And Num(3) = Pw_res(3) Then       'setze alle ports auf 0
      Porta = 0                                             'oder &H00
      Portb = 0                                             'oder &H00
      C1 = 0 : C2 = 0 : C3 = Wert0 : C4 = Wert0             'KOMISCH, wenn ich die 4 pin vom port C auf 0 setze, macht der uP RESET!!???!!
      Portc.4 = 0 : Portc.5 = 0 : Portc.6 = 0 : Portc.7 = 0
      For Pos = 1 To 20
         Writeeeprom Wert0 , Pos
         Reset Watchdog
      Next
      Gosub Best_tief
      Goto Abfrage
   End If

   If Num(1) = Pw_set(1) And Num(2) = Pw_set(2) And Num(3) = Pw_set(3) Then       'setze alle ports auf 1
      Porta = 255                                           'oder &HFF
      Portb = 255                                           'oder &HFF
      C1 = 1 : C2 = 1 : C3 = 1 : C4 = 1
      For Pos = 1 To 20
         Writeeeprom Wert1 , Pos
         Reset Watchdog
      Next
      Gosub Best_hoch
      Goto Abfrage
   End If

   If Num(1) = Pw_end(1) And Num(2) = Pw_end(2) And Num(3) = Pw_end(3) Then
      Pw_ok = 0
      Decode_ok = 0
      Zaehler0 = 1
      Zaehler1 = 0
      Zaehler2 = 1
      Zaehler3 = 0
      Zaehler5 = 1
      Gosub Ende
      Goto Abfrage
   End If

   If Num(1) = Pw_aendere(1) And Num(2) = Pw_aendere(2) And Num(3) = Pw_aendere(3) Then
      Pw_var = 1
      Gosub Best_tief2
      Goto Abfrage
   End If

   Gosub Reset_zaehler
   Gosub Blink4
Goto Abfrage


Ende:
   Waitms Tx_delay
   Reset Watchdog
   Ptt = 1
   Waitms Nf_delay
   Reset Watchdog
   Sound Nfout , Dauer_tonhoch , Ton_hoch                   'nfout auf pin "nfout", der dauer von 200 ms und der impulse
   Waitms 100
   Sound Nfout , Dauer_tonhoch , Ton_hoch                   'nfout auf pin "nfout", der dauer von 200 ms und der impulse
   Waitms 100
   Sound Nfout , Dauer_tonhoch , Ton_hoch                   'nfout auf pin "nfout", der dauer von 200 ms und der impulse
   Ptt = 0
   Reset Watchdog
   Return


Ende1:
   Waitms Tx_delay
   Reset Watchdog
   Ptt = 1
   Waitms Nf_delay
   Reset Watchdog
   Sound Nfout , Dauer_tonhoch , Ton_hoch                   'nfout auf pin "nfout", der dauer von 200 ms und der impulse
   Waitms 100
   Sound Nfout , Dauer_tonhoch , Ton_hoch                   'nfout auf pin "nfout", der dauer von 200 ms und der impulse
   Waitms 100
   Sound Nfout , Dauer_tonhoch , Ton_hoch                   'nfout auf pin "nfout", der dauer von 200 ms und der impulse
   Waitms 100
   Sound Nfout , Dauer_tonhoch , Ton_hoch                   'nfout auf pin "nfout", der dauer von 200 ms und der impulse
   Waitms 100
   Sound Nfout , Dauer_tonhoch , Ton_hoch                   'nfout auf pin "nfout", der dauer von 200 ms und der impulse
   Waitms 100
   Sound Nfout , Dauer_tonhoch , Ton_hoch                   'nfout auf pin "nfout", der dauer von 200 ms und der impulse
   Ptt = 0
   Reset Watchdog
   Return


Reset_zaehler:
   Waitms Tx_delay
   Reset Watchdog
   Ptt = 1
   Waitms Nf_delay
   Reset Watchdog
   Sound Nfout , Dauer_tonhoch , Ton_hoch                   'nfout auf pin "nfout", der dauer von 200 ms und der impulse
   Sound Nfout , Dauer_tontief , Ton_tief
   Waitms 100
   Sound Nfout , Dauer_tontief , Ton_tief
   Waitms 100
   Sound Nfout , Dauer_tontief , Ton_tief
   Ptt = 0
   Reset Watchdog
   Return


Best_tief:
   Waitms Tx_delay
   Reset Watchdog
   Ptt = 1
   Waitms Nf_delay
   Reset Watchdog
   Sound Nfout , Dauer_tonhoch , Ton_hoch                   'nfout auf pin "nfout", der dauer von 200 ms und der impulse
   Sound Nfout , Dauer_tontief , Ton_tief
   Waitms 100
   Sound Nfout , Dauer_tontief , Ton_tief
   Ptt = 0
   Reset Watchdog
   Return


Best_tief2:
   Waitms Tx_delay
   Reset Watchdog
   Ptt = 1
   Waitms Nf_delay
   Reset Watchdog
   Sound Nfout , Dauer_tonhoch , Ton_hoch                   'nfout auf pin "nfout", der dauer von 200 ms und der impulse
   Waitms 100
   Sound Nfout , Dauer_tonhoch , Ton_hoch                   'nfout auf pin "nfout", der dauer von 200 ms und der impulse
   Waitms 100
   Sound Nfout , Dauer_tontief , Ton_tief
   Waitms 100
   Sound Nfout , Dauer_tontief , Ton_tief
   Ptt = 0
   Reset Watchdog
   Return


Best_hoch:
   Waitms Tx_delay
   Reset Watchdog
   Ptt = 1
   Waitms Nf_delay
   Reset Watchdog
   Sound Nfout , Dauer_tontief , Ton_tief
   Sound Nfout , Dauer_tonhoch , Ton_hoch                   'nfout auf pin "nfout", der dauer von 200 ms und der impulse
   Waitms 100
   Sound Nfout , Dauer_tonhoch , Ton_hoch                   'nfout auf pin "nfout", der dauer von 200 ms und der impulse
   Ptt = 0
   Reset Watchdog
   Return


Best_hoch2:
'   Waitms Tx_delay
   Reset Watchdog
   Ptt = 1
   Waitms Nf_delay
   Reset Watchdog
   Sound Nfout , Dauer_tontief , Ton_tief
   Waitms 100
   Sound Nfout , Dauer_tontief , Ton_tief
   Waitms 100
   Sound Nfout , Dauer_tonhoch , Ton_hoch                   'nfout auf pin "nfout", der dauer von 200 ms und der impulse
   Waitms 100
   Sound Nfout , Dauer_tonhoch , Ton_hoch                   'nfout auf pin "nfout", der dauer von 200 ms und der impulse
   Ptt = 0
   Reset Watchdog
   Return


Best_biep:
'   Waitms Tx_delay
   Reset Watchdog
   Ptt = 1
   Waitms Nf_delay
   Reset Watchdog
   Sound Nfout , Dauer_tonhoch , Ton_hoch                   'nfout auf pin "nfout", der dauer von 200 ms und der impulse
   Ptt = 0
   Reset Watchdog
   Return


Ir3ubc:
   If Portb.6 = 1 Then
      If Portb.7 = 1 Then
         Toggle Portb.7
         Merker2 = 1
      End If

      Waitms Tx_delay
      Reset Watchdog
      Ptt = 1
      Waitms Nf_delay
      Reset Watchdog

      For Merker = 0 To 47
         Dauer = Lookup(merker , Tabelle_dauer)
         If Dauer > 0 Then
            Sound Nfout , Dauer , 400
         End If                                             'sound ausgabepin, dauervon 0 bis 65535 (desto grer desto lnger der Ton), frequenz (desto tiefer die zahl desto hher die frequenz)
         Waitms 80
         Reset Watchdog
      Next

      If Merker2 = 1 Then
         Merker2 = 0
         Toggle Portb.7
      End If

      Ptt = 0
   End If

   Return


Blink2:                                                     '2 Blinkimpulse am Led fr Password erkannt
   Waitms 300
   Pulseout Portd , 0 , 100000
   Waitms 100
   Pulseout Portd , 0 , 100000
   Reset Watchdog
   Return


Blink4:                                                     '4 Blinkimpulse am Led fr falsche Einzel Nummerneingabe
   Waitms 300
   Pulseout Portd , 0 , 100000
   Waitms 100
   Pulseout Portd , 0 , 100000
   Waitms 100
   Pulseout Portd , 0 , 100000
   Waitms 100
   Pulseout Portd , 0 , 100000
   Reset Watchdog
   Return


Blink6:                                                     '6 Blinkimpulse am Led fr RESET
   Waitms 300
   Pulseout Portd , 0 , 100000
   Waitms 100
   Pulseout Portd , 0 , 100000
   Waitms 100
   Pulseout Portd , 0 , 100000
   Waitms 100
   Pulseout Portd , 0 , 100000
   Waitms 100
   Pulseout Portd , 0 , 100000
   Waitms 100
   Pulseout Portd , 0 , 100000
   Reset Watchdog
   Return



Tabelle_dauer:
Data 80% , 80% , 0% , 0% , 0% , 80% , 240% , 80% , 0% , 0% , 0% , 80% , 80% , 80% , 240% , 240% , 0% , 0% , 0% , 80% , 80% , 240% , 0% , 0% , 0% , 240% , 80% , 80% , 80% , 0% , 0% , 0% , 240% , 80% , 240% , 80% , 0% , 0% , 0% , 0% , 0% , 0% , 0% , 0% , 0% , 240% , 80% , 240%

     'I = . .                    R = . _ .                         3 = . . . _ _                                  U = . . _                         B = _ . . .                             C = _ . _ .                                                            K = _ . _


'   If Num(1) = Pw_b1(2) And Num(2) = Pw_b1(3) Then
'      If Num(3) = 12 Then
'         Toggle B1
'         Ab1 = B1
'         Writeeeprom Ab1 , 9
'      End If
'
'      If Num(3) = 11 Or Num(3) = 12 Then
'            If B1 = 1 Then
'               Gosub Best_hoch
'            Else
'               Gosub Best_tief
'            End If
'         Goto Abfrage
'      End If
'   End If
'
'   If Num(1) = Pw_b2(2) And Num(2) = Pw_b2(3) Then
'      If Num(3) = 12 Then
'         Toggle B2
'         Ab2 = B2
'         Writeeeprom Ab2 , 10
'      End If
'
'      If Num(3) = 11 Or Num(3) = 12 Then
'            If B2 = 1 Then
'               Gosub Best_hoch
'            Else
'               Gosub Best_tief
'            End If
'         Goto Abfrage
'      End If
'   End If
'
'   If Num(1) = Pw_b3(2) And Num(2) = Pw_b3(3) Then
'      If Num(3) = 12 Then
'         Toggle B3
'         Ab3 = B3
'         Writeeeprom Ab3 , 11
'      End If
'
'      If Num(3) = 11 Or Num(3) = 12 Then
'            If B3 = 1 Then
'               Gosub Best_hoch
'            Else
'               Gosub Best_tief
'            End If
'         Goto Abfrage
'      End If
'   End If
'
'   If Num(1) = Pw_b4(2) And Num(2) = Pw_b4(3) Then
'      If Num(3) = 12 Then
'         Toggle B4
'         Ab4 = B4
'         Writeeeprom Ab4 , 12
'      End If
'
'      If Num(3) = 11 Or Num(3) = 12 Then
'            If B4 = 1 Then
'               Gosub Best_hoch
'            Else
'               Gosub Best_tief
'            End If
'         Goto Abfrage
'      End If
'   End If
'
'   If Num(1) = Pw_b5(2) And Num(2) = Pw_b5(3) Then
'      If Num(3) = 12 Then
'         Toggle B5
'         Ab5 = B5
'         Writeeeprom Ab5 , 13
'      End If
'
'      If Num(3) = 11 Or Num(3) = 12 Then
'            If B5 = 1 Then
'               Gosub Best_hoch
'            Else
'               Gosub Best_tief
'            End If
'         Goto Abfrage
'      End If
'   End If
'
'   If Num(1) = Pw_b6(2) And Num(2) = Pw_b6(3) Then
'      If Num(3) = 12 Then
'         Toggle B6
'         Ab6 = B6
'         Writeeeprom Ab6 , 14
'      End If
'
'      If Num(3) = 11 Or Num(3) = 12 Then
'            If B6 = 1 Then
'               Gosub Best_hoch
'            Else
'               Gosub Best_tief
'            End If
'         Goto Abfrage
'      End If
'   End If
'
'   If Num(1) = Pw_b7(2) And Num(2) = Pw_b7(3) Then
'      If Num(3) = 12 Then
'         Toggle B7
'         Ab7 = B7
'         Writeeeprom Ab7 , 15
'      End If
'
'      If Num(3) = 11 Or Num(3) = 12 Then
'            If B7 = 1 Then
'               Gosub Best_hoch
'            Else
'               Gosub Best_tief
'            End If
'         Goto Abfrage
'      End If
'   End If
'
'   If Num(1) = Pw_b8(2) And Num(2) = Pw_b8(3) Then
'      If Num(3) = 12 Then
'         Toggle B8
'         Ab8 = B8
'         Writeeeprom Ab8 , 16
'      End If
'
'      If Num(3) = 11 Or Num(3) = 12 Then
'            If B8 = 1 Then
'               Gosub Best_hoch
'            Else
'               Gosub Best_tief
'            End If
'         Goto Abfrage
'      End If
'   End If
'
'   If Num(1) = Pw_c1(2) And Num(2) = Pw_c1(3) Then
'      If Num(3) = 12 Then
'         Toggle C1
'         Ac1 = C1
'         Writeeeprom Ac1 , 17
'      End If
'
'      If Num(3) = 11 Or Num(3) = 12 Then
'            If C1 = 1 Then
'               Gosub Best_hoch
'            Else
'               Gosub Best_tief
'            End If
'         Goto Abfrage
'      End If
'   End If
'
'   If Num(1) = Pw_c2(2) And Num(2) = Pw_c2(3) Then
'      If Num(3) = 12 Then
'         Toggle C2
'         Ac2 = C2
'         Writeeeprom Ac2 , 18
'      End If
'
'      If Num(3) = 11 Or Num(3) = 12 Then
'            If C2 = 1 Then
'               Gosub Best_hoch
'            Else
'               Gosub Best_tief
'            End If
'         Goto Abfrage
'      End If
'   End If
'
'   If Num(1) = Pw_c3(2) And Num(2) = Pw_c3(3) Then
'      If Num(3) = 12 Then
'         Toggle C3
'         Ac3 = C3
'         Writeeeprom Ac3 , 19
'      End If
'
'      If Num(3) = 11 Or Num(3) = 12 Then
'            If C3 = 1 Then
'               Gosub Best_hoch
'            Else
'               Gosub Best_tief
'            End If
'         Goto Abfrage
'      End If
'   End If
'
'   If Num(1) = Pw_c4(2) And Num(2) = Pw_c4(3) Then
'      If Num(3) = 12 Then
'         Toggle C4
'         Ac4 = C4
'         Writeeeprom Ac4 , 20
'      End If
'
'      If Num(3) = 11 Or Num(3) = 12 Then
'            If C4 = 1 Then
'               Gosub Best_hoch
'            Else
'               Gosub Best_tief
'            End If
'         Goto Abfrage
'      End If
'   End If